/**************************************************************************//**
 * @item     CosyOS Kernel
 * @file     os_starter.c
 * @brief    启动任务（Starter）
 * @author   迟凯峰
 * @version  V3.3.0
 * @date     2023.07.15
 ******************************************************************************/

#include "os_link.h"

uCreateTask(Starter, SYSCFG_TASKPRIORITY - 2, __STACKSIZE_STARTER__, 0, 0)
{
	#if OS_TIMINTTOTAL || OS_TIMQRYTOTAL
	u8 i;
	#if OS_TIMINTTOTAL
	i = OS_TIMINTTOTAL;
	while(i--)
	{
		if(vTIMINT_TYPE[i])
		{
			sStartTask_TimInt(i);
		}
	}
	#endif
	#if OS_TIMQRYTOTAL
	i = OS_TIMQRYTOTAL - 1;
	while(i--)
	{
		if(vTIMQRY_TYPE[i])
		{
			sStartTask_TimQry(i);
		}
	}
	#endif
	#endif
	start_hook();
	uDeleteTasking;
	uEndTasking;
}
