/**************************************************************************//**
 * @file     test_mailbox.c
 * @brief    Ϣ
 * @detail   Ϣ䣬ʵTASK_ATASK_Bѭ
             TASK_0дڴӡÿӵļ
 * @service  uRecvMailuSendMail
 * @author   ٿ
 * @version  V2.0.0
 * @date     2023.08.10
 ******************************************************************************/

#include "test.h"
#if TESTOBJ == TOBJ_MAILBOX

/*
 * û
 */

// ͣ0׼ԣ1ṹ/ԣ
// ׼ԣΪͣtFetionø߿ɿԵѭУ飬ͨǷ
// ṹ/ԣAΪṹͣBΪͣڸʱͨǷ
#define TESTTYPE    0

////////////////////////////////////////////////////////////////////////////////

static unsigned long _SYS_MEM_ vCounter_A = 0;
static unsigned long _SYS_MEM_ vCounter_B = 0;
#if TESTTYPE == 0
typedef tFetion tMail, tMail_A, tMail_B;
#else
typedef struct
{
	float m_f;
	u8 m_u8;
	u16 m_u16;
	u32 m_u32;
	s8 m_s8;
	s16 m_s16;
	s32 m_s32;
	double m_d;
}tMail_A;
typedef s32 tMail_B[6];
static const tMail_A mailbox_A = {3.1415926, 0x0F, 0x0F0F, 0x0F0F0F0F, 0xE0, 0xE0E0, 0xE0E0E0E0, -6295141.3};
static const tMail_B mailbox_B = {0xA0, 0xA0A0, 0xA0A0A0A0, 0x0B, 0x0B0B, 0x0B0B0B0B};
#endif



/*
 * Ϣ
 */

uCreateMailbox(MAILBOX_A, tMail_A);
uCreateMailbox(MAILBOX_B, tMail_B);



/*
 * 
 */

uExternTask(TASK_0);
uExternTask(TASK_A);
uExternTask(TASK_B);



/*
 * 
 */

void start_hook(void)
{
	/* ԣȷʼMAILBOX_A */
	#if TESTTYPE == 0
	static const tMail mailbox_s = 1;
	uSendMail(MAILBOX_A, (void *)&mailbox_s);
	#else
	uSendMail(MAILBOX_A, (void *)&mailbox_A);
	#endif
	/*  */
	uStartTask(TASK_0, 0);
	uStartTask(TASK_A, 0);
	uStartTask(TASK_B, 0);
	/* ӡ */
	printf("%s\n\n", "TASK_A | TASK_B | TASK_A - TASK_B");
}



/*
 * 
 */

/* TASK_0 */
uCreateTask(TASK_0, PRIORITY_HIGH, TASKSTACKSIZE, 0, 0)
{
	static unsigned long counter_a;
	static unsigned long counter_b;
	uDelay_s(1);
	counter_a = vCounter_A;
	counter_b = vCounter_B;
	vCounter_A = 0;
	vCounter_B = 0;
	printf("%lu, ", counter_a);
	printf("%lu, ", counter_b);
	printf("%d \n", (int)(counter_a - counter_b));
	uEndTasking;
}

/* TASK_A */
uCreateTask(TASK_A, PRIORITY_MID, TASKSTACKSIZE, 0, 0)
{
	#if TESTTYPE == 0
	static tMail mailbox_s = 0;
	tMail mailbox_r = 0;
	mailbox_s++;
	if(uRecvMail(&mailbox_r, MAILBOX_A, ~0) && mailbox_r == mailbox_s)
	{
		uEnterCritical;
		vCounter_A++;
		uExitCritical;
		mailbox_s++;
		uSendMail(MAILBOX_B, &mailbox_s);
	}
	#else
	tMail_A mailbox_r = {0};
	if(uRecvMail(&mailbox_r, MAILBOX_A, ~0) && !memcmp(&mailbox_r, (void *)&mailbox_A, sizeof(tMail_A)))
	{
		uEnterCritical;
		vCounter_A++;
		uExitCritical;
		uSendMail(MAILBOX_B, (void *)&mailbox_B);
	}
	#endif
	uEndTasking;
}

/* TASK_B */
uCreateTask(TASK_B, PRIORITY_LOW, TASKSTACKSIZE, 0, 0)
{
	#if TESTTYPE == 0
	static tMail mailbox_s = 1;
	tMail mailbox_r = 0;
	mailbox_s++;
	if(uRecvMail(&mailbox_r, MAILBOX_B, ~0) && mailbox_r == mailbox_s)
	{
		uEnterCritical;
		vCounter_B++;
		uExitCritical;
		mailbox_s++;
		uSendMail(MAILBOX_A, &mailbox_s);
	}
	#else
	tMail_B mailbox_r = {0};
	if(uRecvMail(&mailbox_r, MAILBOX_B, ~0) && !memcmp(&mailbox_r, (void *)&mailbox_B, sizeof(tMail_B)))
	{
		uEnterCritical;
		vCounter_B++;
		uExitCritical;
		uSendMail(MAILBOX_A, (void *)&mailbox_A);
	}
	#endif
	uEndTasking;
}



#endif
